module TiInstanceDB(IDB,Instance,emptyIdb,extendIdb,findInst,instType) where
import TiTypes(Type,Subst(..),Types(..),funT,HsIdentI(..),Typing(..),kupscheme)
import TiSolve()
import Unification(match)
import Maybe(mapMaybe)
--import HsIdent -- hmm
import PrettyPrint
import SpecialNames

type Instance i = (Type i,(i,[Type i]))
newtype IDB i = Idb [Instance i] deriving Show

instType ks (c,(v,ctx)) = HsVar v:>:kupscheme ks (funT (ctx++[c]))

fakeInstType (c,(_,ctx)) = (tv t,t) -- vars in the same order as in instType...
  where t = funT (ctx++[c])

emptyIdb = Idb []
--extendIdb1 inst (Idb idb) = Idb (inst:idb)
extendIdb insts (Idb idb) = Idb (insts++idb)

--namesIdb (Idb idb) = [dn|(_,(dn,_))<-idb]

findInst (Idb idb) inst = mapMaybe matchInst idb
  where
    matchInst i@(ip,(dn,ips)) =
      case match [(ip,inst)] of
	Just s -> Just ((dn,apply (S s) ips),(fakeInstType i,S s))
	_ -> Nothing

----
instance (IsSpecialName i,Printable i) => Printable (IDB i) where
  ppi (Idb insts) = vcat (map pinst insts)

pinst (t,(dn,ctx)) = dn<+>"= instance"<+>ctx<+>"=>"<+>t
